package controls;

import java.awt.Color;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import processModel.Process;

public class UnitComboBox extends JComboBox implements EquationField
{
	private String[] units = {"", "J", "K", "m3", "Pa"};
	private String[] labels = {"", "J", "K", "m\u00B3", "Pa"};
	
	public UnitComboBox(Process process)
	{
		for (String label : labels) {
			this.addItem(label);
		}
	}
	
	public void setSelectedItemByString(String label)
	{
		for (int i = 0; i < units.length; i++) {
			if (label.equals(units[i])) {
				super.setSelectedItem(labels[i]);
			}
		}
	}
	
	public String getSelectedItemString()
	{
		return units[this.getSelectedIndex()];
	}

	public void setFieldValue(String value) {
		setSelectedItemByString(value);
	}

	public String getLabel() {
		return "";
	}

	public String getText() {
		return getSelectedItemString();
	}
	
	public void setForeground(Color color)
	{
		// Do nothing
	}
	
	public void setBackground(Color color)
	{
		// Do nothing
	}
	
	public void setSize(int width, int height)
	{
		// Do nothing
	}
}
