/* Generated by Together */

package processView;

import java.io.PrintWriter;
import java.net.URL;
import java.util.Collection;
import java.util.Iterator;

import processModel.Element;
import utilities.AppConstants;
import processModel.Formula;
import processModel.SpecialValue;
import processModel.StateElement;
import processModel.Transition;
import processModel.Unknown;

/** @author kza10 */
public class Externaliser{
    
    private String header = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
    //private String doctype = "<!DOCTYPE individual_solution SYSTEM \"http://ictg.cosc.canterbury.ac.nz:8005/kermit/individual_solution.dtd\">";
    private URL codeBase;
    private ProcessApplet controller;
    public static String SAVE_URL = "save-ontology";
    
    public Externaliser(ProcessApplet c) {
        controller = c;
        codeBase = controller.getCodeBase();
    }

    
    public URL getController(){return codeBase;}
    
    public void saveToXML(PrintWriter out, String userName, String ontologyID, Collection elements) {
        out.println(header);
        out.print(openTag("", AppConstants.ELT_DIAGRAM + AppConstants.S + AppConstants.ATT_USER_NAME + quoted(userName) + AppConstants.S + AppConstants.ATT_ONTOLOGY_ID +
                quoted(ontologyID)));
        Iterator i = elements.iterator();
        while (i.hasNext()) {
            Element component = (Element)i.next();
            out.print(component.toXML(AppConstants.Sx2));            
        }
        out.print(closeTag("", AppConstants.ELT_DIAGRAM));
        out.close();
    }

    public static String ELT_PROBLEM_SOLVING_STEP = "problem-solving-step";
    public static String ELT_PROBLEM_SOLVING_STEP_ITERATION = "problem-solving-step-iteration";
    
    public void saveDiagramToASPIREXML(PrintWriter out, String userName, String ontologyID, java.util.List<StateElement> states, java.util.List<Transition> transitions) {
    	//<problem-solving-step id='0'>
    	out.print(openTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP + attribValuePair(AppConstants.ATT_ID, "0")));
    	//<solution-component label='DiagramComponents'>
    	
    	Iterator s = states.iterator();
    	Iterator t = transitions.iterator();
    	
    	out.print(openTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT + attribValuePair(AppConstants.ATT_LABEL, "State")));
    	
        while (s.hasNext()) {
            StateElement state = (StateElement)s.next();
            out.print(state.toASPIRE_XML(AppConstants.Sx4));            
        }
        out.print(closeTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT));
        
        out.print(openTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT + attribValuePair(AppConstants.ATT_LABEL, "Transition")));
        
        while (t.hasNext()) {
            Transition transition = (Transition)t.next();
            out.print(transition.toASPIRE_XML(AppConstants.Sx4));            
        }
        
        out.print(closeTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT));
        
        out.print(closeTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP)); 
        out.close();
    }
    
    public void saveSpecialValuesToASPIREXML(PrintWriter out, String userName, String ontologyID, java.util.List<SpecialValue> specialValues)
    {
    	out.print(openTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP + attribValuePair(AppConstants.ATT_ID, "1")));
    	out.print(openTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT + attribValuePair(AppConstants.ATT_LABEL, "SpecialValue")));
    	
    	for (SpecialValue specialValue : specialValues)
    	{
    		out.print(specialValue.toASPIRE_XML(AppConstants.Sx4));
    	}
    	
    	out.print(closeTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT));
    	out.print(closeTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP));
    	out.close();
    }
    
    public void saveUnknownsAndFormulasToASPIREXML(PrintWriter out, String userName, String ontologyID, String formulaStepName, java.util.List<Unknown> calculatedUnknowns, java.util.List<Formula> formulas)
    {
    	out.print(openTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP + attribValuePair(AppConstants.ATT_ID, "2")));
    	
    	// Output Unknowns
    	out.print(openTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT + attribValuePair(AppConstants.ATT_LABEL, "Unknown")));
    	for (Unknown unknown : calculatedUnknowns)
    	{
    		out.print(unknown.toASPIRE_XML(AppConstants.Sx4));
    	}
    	out.print(closeTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT));
    	
    	// Output Formulas
    	out.print(openTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT + attribValuePair(AppConstants.ATT_LABEL, formulaStepName)));
    	for (Formula formula : formulas)
    	{
    		out.print(formula.toASPIRE_XML(AppConstants.Sx4));
    		
    	}
    	out.print(closeTag(AppConstants.Sx2, ELT_SOLUTION_COMPONENT));
    	
    	out.print(closeTag(AppConstants.S, ELT_PROBLEM_SOLVING_STEP));
    	out.close();
    }

    public static String openTag(String indent, String content) {
        return indent + "<" + content + ">\n";
    }

    public static String closeTag(String indent, String content) {
        return indent + "</" + content + ">\n";
    }

    public static String emptyTag(String indent, String content) {
        return indent + "<" + content + " />\n";
    }

    public static String attribValuePair(String attribute, String content) {
        return AppConstants.S + attribute + "=\"" + escape(content) + "\"";
    }
    
    public static String quoted(String content) {
        return "=\"" + escape(content) + "\"";
    }
    
    public static String quoted(boolean flag) {
        return "=\"" + escape(Boolean.toString(flag)) + "\"";
    }
    
    public static String tagWithContent(String indent, String tag, String content) {
    	return indent + "<" + tag + ">" + content + "</" + tag + ">\n";
    }

    public static String UNKNOWN = "unknown";
    
    public static String tagWithContent(String indent, String tag, String content, boolean unknown) {
    	return indent + "<" + tag + attribValuePair(UNKNOWN, Boolean.toString(unknown))  + ">" + content + "</" + tag + ">\n";
    }

    public static String escape(String in)
	{
		StringBuffer out = new StringBuffer();

		for (int i = 0; i < in.length(); i++)
		{
			char c = in.charAt(i);

			switch (c)
			{
				case '<':
					out.append("&lt;");
					break;
				case '>':
					out.append("&gt;");
					break;
				case '&':
					out.append("&amp;");
					break;
				case '"':
					out.append("&quot;");
					break;
				default:
					out.append(c);
					break;
			}
		}
		return out.toString();
	}
    
    /* Methods for producing XML for ASPIRE */
 // ASPIRE XML Tags
    
    public static String ELT_SOLUTION_COMPONENT = "solution-component";
    public static String ELT_SOLUTION_COMPONENT_INSTANCE = "solution-component-instance";
    public static String ELT_RELATED_ELEMENT = "related-element";
    public static String ELT_INSTANCE = "instance";
    public static String ELT_VALUE_ELEMENT = "value-element";
    
    public static String ATT_INDEX = "index";
    public static String ATT_CONCEPT_NAME = "concept-name";
    
    
    //<solution-component label='DiagramComponents'>
    public static String openComponentTag(String indent, String label) {
    	return Externaliser.openTag(indent, ELT_SOLUTION_COMPONENT
				+ Externaliser.attribValuePair(AppConstants.ATT_LABEL, label));
    }
    
    // </solution-component>
    public static String closeComponentTag(String indent, String label) {
    	return Externaliser.closeTag(indent, ELT_SOLUTION_COMPONENT);    
    }    
    
    // <solution-component-instance id='0' concept-name='Center'>
    public static String openInstanceTag(String indent, int id, String conceptName) {
    	return Externaliser.openTag(indent, ELT_SOLUTION_COMPONENT_INSTANCE
				+ Externaliser.attribValuePair(AppConstants.ATT_ID, String.valueOf(id))
				+ Externaliser.attribValuePair(ATT_CONCEPT_NAME,conceptName));
    }
    
    // </solution-component-instance>
    public static String closeInstanceTag(String indent) {
    	return Externaliser.closeTag(indent, ELT_SOLUTION_COMPONENT_INSTANCE);
    }
    
    // <related-element index='0'>
    public static String openRelatedSlotTag(String indent, int index) {
    	return Externaliser.openTag(indent, ELT_RELATED_ELEMENT
    			+ Externaliser.attribValuePair(ATT_INDEX, String.valueOf(index)));				
    }
    
    // </related-element>
    public static String closeRelatedSlotTag(String indent) {
    	return Externaliser.closeTag(indent, ELT_RELATED_ELEMENT);
    }
    
    // <instance id='1'></instance>
    public static String relatedInstanceTag(String indent, int id) {
    	return Externaliser.openTag(indent, ELT_INSTANCE
    			+ Externaliser.attribValuePair(AppConstants.ATT_ID, String.valueOf(id)))
    			+ Externaliser.closeTag(indent, ELT_INSTANCE);    	    	
    }

    // <value-element index='0' value='BottomLeft'></value-element>
    public static String valueSlotTag(String indent, int index, String value) {
    	return Externaliser.openTag(indent, ELT_VALUE_ELEMENT
    			+ Externaliser.attribValuePair(ATT_INDEX, String.valueOf(index))
    			+ Externaliser.attribValuePair(AppConstants.ATT_VALUE, value))
    			+ Externaliser.closeTag(indent, ELT_VALUE_ELEMENT);    	    	    
    }
        
}
