package processView;
import com.cloudgarden.layout.AnchorConstraint;
import com.cloudgarden.layout.AnchorLayout;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import processModel.Formula;
import processModel.MathEvaluator;
import processModel.StateElement;
import processModel.Unknown;
import processView.ProcessApplet.TutorStep;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class FormulaPanel extends JPanel implements FocusListener {



	private FormulaWorkspace controller;
	private JComboBox cmbUnknowns;
	private JComboBox cmbFormulas;
	public static int PANEL_HEIGHT = 100; 
	private JPanel jPanel1;
	private Formula selectedFormula;
	private Unknown selectedUnknown;

	private static String SELECT_UNKNOWN = "Select unknown...";
	private static String SELECT_FORMULA = "Select formula...";
	private JButton btnReselectFormula;

	public static final String EQN_FIRST_LAW = "First Law";
	public static final String EQN_DELTA_U = "Delta U Expression";
	public static final String EQN_ISOTHERMAL_WORK = "Isothermal Work";
	public static final String EQN_ISOBARIC_WORK = "Isobaric Work";
	public static final String EQN_IDEAL_GAS_STATE = "Ideal Gas Equation of State";
	public static final String EQN_ADIABATIC = "Adiabatic Equations";
	public static final String EQN_SPECIAL_PROPERTIES = "Special Properties";
	private EquationPanel panSolution;
	private String[] formulaNames = {SELECT_FORMULA, EQN_FIRST_LAW, EQN_DELTA_U, EQN_ISOTHERMAL_WORK, EQN_ISOBARIC_WORK, EQN_IDEAL_GAS_STATE, EQN_ADIABATIC, EQN_SPECIAL_PROPERTIES};
	
	public FormulaPanel(FormulaWorkspace controller) {
		this.controller = controller;
		initGUI();
	}
	
	private void initGUI() {

		BorderLayout thisLayout = new BorderLayout();
		this.setLayout(thisLayout);
		this.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
		this.setMinimumSize(new java.awt.Dimension(545, 84));
		this.setPreferredSize(new java.awt.Dimension(545, 84));
		this.setSize(new java.awt.Dimension(545, 84));
		{
			jPanel1 = new JPanel();
			this.add(jPanel1, BorderLayout.CENTER);
			AnchorLayout jPanel1Layout = new AnchorLayout();
			jPanel1.setLayout(jPanel1Layout);
			jPanel1.setPreferredSize(new java.awt.Dimension(533, 77));
			jPanel1.setSize(new java.awt.Dimension(548, 79));
			jPanel1.setMinimumSize(new java.awt.Dimension(548, 79));
			{
				btnReselectFormula = new JButton();
				jPanel1.add(btnReselectFormula, new AnchorConstraint(6, 2, 298, 897, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_NONE));
				btnReselectFormula.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						formulaSelected();
					}
				});
				btnReselectFormula.setText("Reselect");
				btnReselectFormula.setPreferredSize(new java.awt.Dimension(90, 21));
				btnReselectFormula.setVisible(false);
			}
			{
				panSolution = new EquationPanel(this);
				jPanel1.add(panSolution, new AnchorConstraint(27, 2, 1006, 0, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_ABS));
				panSolution.setPreferredSize(new java.awt.Dimension(531, 45));
				panSolution.setLayout(null);
			}			
			{
				cmbFormulas = new JComboBox(formulaNames);
				jPanel1.add(cmbFormulas, new AnchorConstraint(0, 98, 298, 281, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_ABS));
				cmbFormulas.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						formulaSelected();
					}
				});
				cmbFormulas.setPreferredSize(new java.awt.Dimension(154, 21));
				cmbFormulas.setVisible(false);
			}
			{
				cmbUnknowns = new JComboBox();
				jPanel1.add(cmbUnknowns, new AnchorConstraint(0, 516, 298, 0, AnchorConstraint.ANCHOR_ABS, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_NONE, AnchorConstraint.ANCHOR_ABS));
				cmbUnknowns.addItem(SELECT_UNKNOWN);				
				cmbUnknowns.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						unknownSelected();
					}
				});
				cmbUnknowns.setPreferredSize(new java.awt.Dimension(275, 21));
			}
		}
		this.validate();
				
		// Set disabled colours
		UIManager.put("ComboBox.disabledForeground", new Color(0x22, 0x22, 0x22));		
		
	}
	
	public ProcessApplet getProcessApplet()
	{
		return controller.getController();
	}
	
	public Unknown getSelectedUnknown()
	{
		return (Unknown) cmbUnknowns.getSelectedItem();
	}

	public void evaluateEquation()
	{
		evaluateEquation(true);
	}
	
	public void evaluateEquation(boolean submitAnswer)
	{
		MathEvaluator eval = new MathEvaluator();
		String expression = panSolution.getExpression();
		getSelectedFormula().setExpression(panSolution.getExpressionWithRounding());
		// Remove everything before the '=' sign
		if (expression.indexOf('=') >= 0) {
			expression = expression.substring(expression.indexOf('=')+1).trim();
		}
		try {
			// TODO:  Hack alert:  The evaluator doesn't seem to handle consecutive minus signs well
			expression = expression.replaceAll("--", "+");
			
			eval.setExpression(expression);
			System.out.println("Evaluates to:  " + eval.getValue() + " ( " + expression + ")");
			String units = panSolution.getUnits();
			updateDataSummary((Unknown)cmbUnknowns.getSelectedItem(), eval.getValue(), units);
			controller.getController().updateDataSummary();
		}
		catch (Exception ex)
		{
			System.out.println("Failed to evaluate:  " + expression);
			ex.printStackTrace();
			return;
		}
		if (submitAnswer) {
			getProcessApplet().setCurrentStep(TutorStep.SolvingUnknown);
			if (getProcessApplet().submitStudentSolution()) {
				solutionDone();
			}
		}
	}
	
	public void setEnabled(boolean enabled)
	{
		for (Component component : getComponents()) {
			component.setEnabled(enabled);
		}
		cmbFormulas.setEnabled(enabled);
		btnReselectFormula.setEnabled(enabled);
		cmbUnknowns.setEnabled(enabled);
		panSolution.setEnabled(enabled);
	}
	
	public void butRearrangeClicked()
	{
		rearrangeFormula();
	}
	
	public void focusLost(FocusEvent e) {
	}
	
	public void focusGained(FocusEvent e) {
		// Do nothing
	}

	private void updateDataSummary(Unknown unknown, double value, String units)
	{
		String roundedValue = "";
		if (Math.abs(value) > 10) {
			DecimalFormat oneDigit = new DecimalFormat("#0.0");
			roundedValue = oneDigit.format(value);
		}
		else {
			MathContext mc = new MathContext(3, RoundingMode.HALF_UP);
			BigDecimal bigDecimal = new BigDecimal(value, mc);
			roundedValue = bigDecimal.toPlainString();
		}
		unknown.setUnknownValue(roundedValue, units);
	}
	
	public void setSelectedTextField(String text)
	{
		panSolution.setSelectedFieldText(text);
	}
	
	public void setUnknowns(List<Unknown> unknowns) {		
		for (Unknown unknown : unknowns) {
			cmbUnknowns.addItem(unknown);			
		}
	}
	
	/*public void setComponentEnabled(String step) {
		if (step.equals(FormulaWorkspace.FORMULA)) {
			cmbUnknowns.setEnabled(false);
			cmbFormulas.setEnabled(true);			
		} else if (step.equals(FormulaWorkspace.SUBSTITUTED_FORMULA)) {
			cmbFormulas.setEnabled(false);
			txtFormula.setEnabled(true);
		} else {
			txtFormula.setEnabled(false);			
			txtFormula.setDisabledTextColor(new Color(0x22, 0x22, 0x22));
			txtSolution.setEnabled(true);
		}
	}*/
	
	/*public String getSolution(String step) {
		if (step.equals(FormulaWorkspace.UNKNOWN)) {
			return (String)cmbUnknowns.getSelectedItem();
		} else if (step.equals(FormulaWorkspace.FORMULA)) {
			return (String)cmbFormulas.getSelectedItem();			
		} else if (step.equals(FormulaWorkspace.REARRANGED_FORMULA)) {
			// TODO: Patch this up
			return "";
		} else if (step.equals(FormulaWorkspace.UNKNOWN_VALUE)) {
			return null;
		} else {
			return "";
		}
	}*/
	
	public String getCurentStep() {
		return "";
	}
	
	public void setSelectedFormula(Formula selectedFormula)
	{
		this.selectedFormula = selectedFormula;
		this.selectedFormula.setUnknownID(getSelectedUnknown().getID());
		if (selectedFormula.isRearrangedEquation()) {
			getProcessApplet().setCurrentStep(TutorStep.RearrangingFormula);
		} else {
			getProcessApplet().setCurrentStep(TutorStep.SelectingFormula);
		}
		boolean answerCorrect = getProcessApplet().submitStudentSolution();
		panSolution.constructPanelComponents(selectedFormula, answerCorrect);
		btnReselectFormula.setVisible(true);
	}
	
	public Formula getSelectedFormula()
	{
		return selectedFormula;
	}
	
	/******************************
	 *       
	 *       Action listeners
	 *       
	 ******************************/  	
	private void unknownSelected() {
		if (selectedUnknown != null) {
			selectedUnknown.clearUnknownValue();
		}
		if (cmbUnknowns.getSelectedItem() instanceof Unknown) {
			selectedUnknown = (Unknown)cmbUnknowns.getSelectedItem();
			if (selectedFormula != null) {
				selectedFormula.setUnknownID(selectedUnknown.getID());
			}
			controller.checkAnswer(this, FormulaWorkspace.UNKNOWN, selectedUnknown.toString());
			cmbFormulas.setVisible(true);
		}
	}
	
	private void formulaSelected() 
	{
		if (cmbFormulas.getSelectedIndex() > 0) {
			controller.checkAnswer(this, FormulaWorkspace.FORMULA, (String)cmbFormulas.getSelectedItem());
		}
	}
	
	private void rearrangeFormula() {
		controller.checkAnswer(this, FormulaWorkspace.REARRANGED_FORMULA, (String)cmbFormulas.getSelectedItem());
	}
	
	private void solutionDone() {
		controller.checkAnswer(this, FormulaWorkspace.UNKNOWN_VALUE, "");
	}
}