package processView;

import java.awt.Image;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;

public class ImageCache
{
	private ProcessApplet applet;
	private String imageDirectory = "images";
	private Map<String, Image> imageCache;
	private Map<String, ImageIcon> imageIconCache;
	
	public ImageCache(ProcessApplet applet) {
		this.applet = applet;
		imageCache = new HashMap<String, Image>();
		imageIconCache = new HashMap<String, ImageIcon>();
	}
	
	public ImageIcon getImageIcon(String name)
	{
		ImageIcon imageIcon = imageIconCache.get(name);
		if (imageIcon == null) {
			System.out.println("LOADING IMAGEICON: " + name);
			Image image = loadImage(name);
			imageCache.put(name, image);
			imageIcon = new ImageIcon(image);
			imageIconCache.put(name, imageIcon);
		}
		else {
			System.out.println("READING CACHED IMAGEICON: " + name);
		}
		System.out.println("RETURNING: " + imageIcon);
		return imageIcon;
	}
	
	public Image getImage(String name)
	{
		Image image = imageCache.get(name);
		if (image == null) {
			System.out.println("LOADING IMAGE: " + name);
			image = loadImage(name);
			imageCache.put(name, image);
			imageIconCache.put(name, new ImageIcon(image));
		}
		else {
			System.out.println("READING CACHED IMAGE: " + name);
		}
		System.out.println("RETURNING: " + image);
		return image;
	}
	
	private Image loadImage(String name) {
		Image image = applet.getImage(applet.getDocumentBase(), imageDirectory + "/" + name);
		return image;
	}
}
