package utilities;

import java.awt.Color;
import java.awt.Font;
import java.awt.RenderingHints;

/**
 * Contains constants used by other classes in this applet.
 * @author Kon Zakharov, k.zakharov@cosc.canterbury.ac.nz
 */
public class AppConstants {
	public final static int BUTTON_DIM = 32;
	public final static int ICON_DIM = 24;
	public final static int ARROW_HEAD_SIZE = 15;
	public final static int GRID_SIZE = 15;
	public static final Color BG_COLOR = new Color(218, 218, 218, 190);
	public final static Color GRID_COLOR = new Color(240, 240, 240);
	public final static Color GRID_BG_COLOR = Color.WHITE;
	public final static Color ISOBARIC_COLOR = new Color (62,123,192);
	public final static Color ISOCHORIC_COLOR = new Color (62,206,69);
	public final static Color ISOTHERMAL_COLOR = new Color(224, 230, 65);
	public final static Color ADIABATIC_COLOR = new Color(230, 117,65);
	public final static Color STATE_BOUNDARY_COLOR = Color.black;
	public final static Color STATE_FILL_COLOR = Color.lightGray;
	public final static Color STATE_TEXT_COLOR = Color.DARK_GRAY;
	
	public final static RenderingHints ANTIALIAS_Hint =
        new RenderingHints(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
	public static final int FONT_SIZE = 15;
	public static final Font ARIAL_FONT = new Font("Arial", java.awt.Font.ITALIC, FONT_SIZE);
	
	public static final int MINIMUM_HANDLE_SIZE = 4;
	public static final int MINIMUM_STATE_SIZE = 20;
	public static final int MINIMUM_TRANSITION_SIZE = 60;
	
	public static final int RESIZE_ELEMENT = 1000; // can be any unused number
	public static final int MOVE_ELEMENT = 1001; // can be any unused number
	public static final int RESIZE_OWNER = 1002; // can be any unused number
	
//	 XML related constants
    
	public static String ATT_ID = "id";
	public static String ELT_DIAGRAM = "diagram";
	public static String ATT_VALUE = "value";
	public static String ATT_LABEL = "label";
	
	public static String ELT_ADIABATIC_C = "adiabaticcompression";
	public static String ELT_ADIABATIC_E = "adiabaticexpansion";
	public static String ELT_ISOBARTIC_C = "isobarticcompression";
	public static String ELT_ISOBARTIC_E = "isobarticexpansion";
	public static String ELT_ISOCHORIC_PI = "isochoricpressureincrease";
	public static String ELT_ISOCHORIC_PD = "isochoricpressuredecrease";
	public static String ELT_ISOTHERMAL_C = "isothermalcompression";
	public static String ELT_ISOTHERMAL_E = "isothermalexpansion";
	
	public static String NEW_LINE = "\n";
    public static String S = " ";
    public static String Sx2 = S + S;
    public static String Sx4 = Sx2 + Sx2;
    public static String Sx6 = Sx2 + Sx2 + Sx2;
    
    public static String ATT_CONCEPT_ID = "concept-id";
    public static String ATT_HANDLE_NUMBER = "handle-number";
    public static String ATT_POINT = "point";
    
    
    public static String ATT_STATUS = "status";
    public static String ATT_ONTOLOGY_ID = "ontology-id";    
    public static String ATT_USER_NAME = "user-name";
    public static String ATT_XVAL = "xval";
    public static String ATT_YVAL = "yval";
    public static String ATT_REPEATABLE = "repeatable";
    
    public static String ATT_MIN_CARDINALITY = "min-cardinality";
    public static String ATT_MAX_CARDINALITY = "max-cardinality";
    public static String ATT_NAME = "name";
    public static String ATT_TYPE = "type";
    public static String ATT_DESCRIPTION = "description";
    public static String ATT_FREETEXT = "free-text";
    
    public static String ATT_X = "x";
    public static String ATT_Y = "y";
    public static String ATT_REF = "ref";
    public static String ELT_POINT = "point";
    public static String ELT_ATTACHED_TRANSITION = "attached-transition";
    public static String ELT_STATE = "state";
    
    
    
    public static String ATT_X1 = "x1";
    public static String ATT_Y1 = "y1";
    public static String ATT_X2 = "x2";
    public static String ATT_Y2 = "y2";
    
    
    
    public static String ATT_LINE_1_REF = "line-1-ref";
    public static String ATT_LINE_2_REF = "line-2-ref";
    public static String ATT_RADIUS = "radius";   
    public static String ATT_WIDTH = "width";
    public static String ATT_HEIGHT = "height";
    public static String ATT_UNKNOWN = "unknown";    
    
    public static String ELT_ANGLE = "angle";
    public static String ELT_AXES = "axes";
    
    public static String ELT_RESULTANT_FORCE = "resultant-force";    
    
    
    public static String ELT_LABEL = "label";
    public static String ELT_DISTANCE = "distance";
    public static String ELT_RECTANGLE = "rectangle";
    public static String ELT_ELLIPSE = "ellipse";
    public static String ELT_POINT_LABEL = "point-label";
    public static String ELT_UNITS = "units";
    
    public static String ELT_TEMPERATURE = "temperature";
    public static String ELT_PRESSURE = "pressure";
    public static String ELT_VOLUME = "volume";
    public static String ELT_DELTA = "delta";      
    public static String ELT_WORK = "work";
    public static String ELT_HEAT= "heat";
    
    public static String ELT_CENTER = "center";
    public static String ELT_THICK_LINE = "thick-line";
    
    
    
    public static String ELT_CONCEPT = "concept";
    public static String ELT_CONCEPT_REFERENCE = "concept-reference";
    public static String ELT_GENERALISE_CONNECTOR = "generalise-connector";
    public static String ELT_DIMENSION = "dimension";
    public static String ELT_ONTOLOGY = "ontology";
    public static String ELT_POSITION = "position";
    public static String ELT_PROPERTY = "property";
    public static String ELT_RELATIONSHIP = "relationship";
    public static String ELT_MINIMUM = "minimum";
    public static String ELT_MAXIMUM = "maximum";
    public static String ELT_SYMBOL = "symbol";
    public static String AVAILABLE = "available";
    public static String NOT_AVAILABLE = "not-available";
    
    
    public static final int ANGLE = 0;
    public static final int AXES = 1;
    public static final int FORCE = 2;
    public static final int LINE = 3;
    public static final int POINT = 4;
    public static final int LABEL = 5;
    public static final int MAGNITUDE = 6;
    public static final int FX_MAGNITUDE = 7;
    public static final int FY_MAGNITUDE = 8;
    public static final int POINT_ON_LINE = 9;
    public static final int ATTACHED_LINE = 10;
    public static final int ATTACHED_POINT = 11;
    public static final int OWNER_LINE = 12; 
    public static final int POINT_LABEL = 13;
    public static final int DIAGRAM = 14;
    public static final int CENTER = 15;
    public static final int UNITS = 16;
    public static final int DISTANCE = 17;
    public static final int RECTANGLE = 18;
    public static final int ELLIPSE = 19;
    public static final int THICK_LINE = 20;
    public static final int RESULTANT_FORCE = 21;
    
    
    public static final String DELETE = "DELETE";
    public static final String END = "END";
    public static final String HTML_OP = "<HTML>";
    public static final String HTML_CL = "</HTML>";
    public static final String BR_SINGLE = "<BR>";
    public static final String BR_DOUBLE = BR_SINGLE + BR_SINGLE;
    public static final int MESSAGE_WIDTH_IN_CHARS = 60;
    public static final String SYSTEM_ERROR_TITLE = "Internal System Error";
    public static final String SYSTEM_ERROR = "Internal system error:";
    public static final String NETWORK_ERROR_MSG = "Please make sure your network connection is still alive.";
    public static final String ERROR_MSG = "If the error persists, contact the System Administrator";
    
    public static final Font arial9 = new Font("Arial", Font.PLAIN, 9);
    public static final Font arial11 = new Font("Arial", Font.PLAIN, 11);
    public static final Font arial = new Font("Arial", java.awt.Font.PLAIN, 11);
    public static final Font arialBold = new Font("Arial", java.awt.Font.BOLD, 12);
    public static final Color TRANSPARENT_GRAY = new Color(210, 210, 210, 90);
    public static final Color WHITE = Color.white;
    public static final Color GRAY = Color.gray;
    public static final Color LIGHT_GRAY = Color.lightGray;
    public static final Color DARK_GRAY = Color.darkGray;
    public static final Color GREEN = Color.green;
    public static final Color BLACK = Color.black;
    public static final Color RED = Color.red;
    public static final Color BLUE = Color.blue;
}